]> git.saurik.com Git - apple/shell_cmds.git/blob - mktemp/mktemp.1
shell_cmds-216.40.4.tar.gz
[apple/shell_cmds.git] / mktemp / mktemp.1
1 .\" Copyright (c) 1989, 1991, 1993
2 .\" The Regents of the University of California. All rights reserved.
3 .\"
4 .\" Redistribution and use in source and binary forms, with or without
5 .\" modification, are permitted provided that the following conditions
6 .\" are met:
7 .\" 1. Redistributions of source code must retain the above copyright
8 .\" notice, this list of conditions and the following disclaimer.
9 .\" 2. Redistributions in binary form must reproduce the above copyright
10 .\" notice, this list of conditions and the following disclaimer in the
11 .\" documentation and/or other materials provided with the distribution.
12 .\" 4. Neither the name of the University nor the names of its contributors
13 .\" may be used to endorse or promote products derived from this software
14 .\" without specific prior written permission.
15 .\"
16 .\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
17 .\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 .\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19 .\" ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
20 .\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21 .\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22 .\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23 .\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24 .\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25 .\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26 .\" SUCH DAMAGE.
27 .\"
28 .\" From: $OpenBSD: mktemp.1,v 1.8 1998/03/19 06:13:37 millert Exp $
29 .\" $FreeBSD$
30 .\"
31 .Dd December 30, 2005
32 .Dt MKTEMP 1
33 .Os
34 .Sh NAME
35 .Nm mktemp
36 .Nd make temporary file name (unique)
37 .Sh SYNOPSIS
38 .Nm
39 .Op Fl d
40 .Op Fl q
41 .Op Fl t Ar prefix
42 .Op Fl u
43 .Ar template ...
44 .Nm
45 .Op Fl d
46 .Op Fl q
47 .Op Fl u
48 .Fl t Ar prefix
49 .Sh DESCRIPTION
50 The
51 .Nm
52 utility takes each of the given file name templates and overwrites a
53 portion of it to create a file name.
54 This file name is unique
55 and suitable for use by the application.
56 The template may be
57 any file name with some number of
58 .Ql X Ns s
59 appended
60 to it, for example
61 .Pa /tmp/temp.XXXX .
62 The trailing
63 .Ql X Ns s
64 are replaced with the current process number and/or a
65 unique letter combination.
66 The number of unique file names
67 .Nm
68 can return depends on the number of
69 .Ql X Ns s
70 provided; six
71 .Ql X Ns s
72 will
73 result in
74 .Nm
75 selecting 1 of 56800235584 (62 ** 6) possible file names.
76 On case-insensitive file systems, the effective number of unique
77 names is significantly less; given six
78 .Ql X Ns s ,
79 .Nm
80 will instead select 1 of 2176782336 (36 ** 6) possible unique file names.
81 .Pp
82 If
83 .Nm
84 can successfully generate a unique file name, the file
85 is created with mode 0600 (unless the
86 .Fl u
87 flag is given) and the filename is printed
88 to standard output.
89 .Pp
90 If the
91 .Fl t Ar prefix
92 option is given,
93 .Nm
94 will generate a template string based on the
95 .Ar prefix
96 and the
97 .Dv _CS_DARWIN_USER_TEMP_DIR
98 configuration variable if available.
99 Fallback locations if
100 .Dv _CS_DARWIN_USER_TEMP_DIR
101 is not available are
102 .Ev TMPDIR
103 and
104 .Pa /tmp .
105 Care should
106 be taken to ensure that it is appropriate to use an environment variable
107 potentially supplied by the user.
108 .Pp
109 If no arguments are passed or if only the
110 .Fl d
111 flag is passed
112 .Nm
113 behaves as if
114 .Fl t Li tmp
115 was supplied.
116 .Pp
117 Any number of temporary files may be created in a single invocation,
118 including one based on the internal template resulting from the
119 .Fl t
120 flag.
121 .Pp
122 The
123 .Nm
124 utility is provided to allow shell scripts to safely use temporary files.
125 Traditionally, many shell scripts take the name of the program with
126 the pid as a suffix and use that as a temporary file name.
127 This
128 kind of naming scheme is predictable and the race condition it creates
129 is easy for an attacker to win.
130 A safer, though still inferior, approach
131 is to make a temporary directory using the same naming scheme.
132 While
133 this does allow one to guarantee that a temporary file will not be
134 subverted, it still allows a simple denial of service attack.
135 For these
136 reasons it is suggested that
137 .Nm
138 be used instead.
139 .Sh OPTIONS
140 The available options are as follows:
141 .Bl -tag -width indent
142 .It Fl d
143 Make a directory instead of a file.
144 .It Fl q
145 Fail silently if an error occurs.
146 This is useful if
147 a script does not want error output to go to standard error.
148 .It Fl t Ar prefix
149 Generate a template (using the supplied
150 .Ar prefix
151 and
152 .Ev TMPDIR
153 if set) to create a filename template.
154 .It Fl u
155 Operate in
156 .Dq unsafe
157 mode.
158 The temp file will be unlinked before
159 .Nm
160 exits.
161 This is slightly better than
162 .Xr mktemp 3
163 but still introduces a race condition.
164 Use of this
165 option is not encouraged.
166 .El
167 .Sh EXIT STATUS
168 .Ex -std
169 .Sh EXAMPLES
170 The following
171 .Xr sh 1
172 fragment illustrates a simple use of
173 .Nm
174 where the script should quit if it cannot get a safe
175 temporary file.
176 .Bd -literal -offset indent
177 tempfoo=`basename $0`
178 TMPFILE=`mktemp /tmp/${tempfoo}.XXXXXX` || exit 1
179 echo "program output" >> $TMPFILE
180 .Ed
181 .Pp
182 To allow the use of $TMPDIR:
183 .Bd -literal -offset indent
184 tempfoo=`basename $0`
185 TMPFILE=`mktemp -t ${tempfoo}` || exit 1
186 echo "program output" >> $TMPFILE
187 .Ed
188 .Pp
189 In this case, we want the script to catch the error itself.
190 .Bd -literal -offset indent
191 tempfoo=`basename $0`
192 TMPFILE=`mktemp -q /tmp/${tempfoo}.XXXXXX`
193 if [ $? -ne 0 ]; then
194 echo "$0: Can't create temp file, exiting..."
195 exit 1
196 fi
197 .Ed
198 .Sh SEE ALSO
199 .Xr mkdtemp 3 ,
200 .Xr mkstemp 3 ,
201 .Xr mktemp 3 ,
202 .Xr confstr 3 ,
203 .Xr environ 7
204 .Sh HISTORY
205 A
206 .Nm
207 utility appeared in
208 .Ox 2.1 .
209 This implementation was written independently based on the
210 .Ox
211 man page, and
212 first appeared in
213 .Fx 2.2.7 .
214 This man page is taken from
215 .Ox .